---- Environment ----

data_s, return_s, dip_s, current, ip = {}, {}, {}, {}, 1


---- Operators ----

function nop () end

function drop ()
    table.remove(data_s)
end

function dup ()
    table.insert(data_s, data_s[#data_s])
end

function over ()
    table.insert(data_s, data_s[#data_s-1])
end

function swap ()
    data_s[#data_s-1], data_s[#data_s]
    = data_s[#data_s], data_s[#data_s-1]
end

function rot ()
    data_s[#data_s-2], data_s[#data_s-1], data_s[#data_s]
    = data_s[#data_s-1], data_s[#data_s], data_s[#data_s-2]
end

function dip ()
    local v = current[ip]
    ip = ip + 1
    table.insert(return_s, {current, ip})
    table.insert(return_s, {{undip}, 1})
    table.insert(dip_s, table.remove(data_s))
    current, ip = v, 1
end

function undip ()
    table.insert(data_s, table.remove(dip_s))
end

function op_not ()
    table.insert(data_s, not table.remove(data_s))
end

function suc ()
    table.insert(data_s, table.remove(data_s) + 1)
end

function add ()
    table.insert(data_s, table.remove(data_s) + table.remove(data_s))
end

function mul ()
    table.insert(data_s, table.remove(data_s) * table.remove(data_s))
end

function eq ()
    table.insert(data_s, table.remove(data_s) == table.remove(data_s))
end

function cat ()
    local v2, v1 = table.remove(data_s), table.remove(data_s)
    table.insert(data_s, v1 .. v2)
end

function get ()
    table.insert(data_s, table.remove(data_s)[table.remove(data_s)])
end

function set ()
    local v = table.remove(data_s)
    table.remove(data_s)[table.remove(data_s)] = v
end

function to_list ()
    local s, v = table.remove(data_s), {}
    for i = 1, #s do
        table.insert(v, s:sub(i, i))
    end
    table.insert(data_s, v)
end

function new_list ()
    table.insert(data_s, {})
end

function length ()
    table.insert(data_s, #table.remove(data_s))
end

function random ()
    table.insert(data_s, math.random(table.remove(data_s)))
end

function iff ()
    if not table.remove(data_s) then
        ip = ip + 2
    end
end

function elsef ()
    ip = ip + 1
end

function op_while ()
    if not table.remove(data_s) then
        ip = #current + 1
    end
end

function again ()
    ip = 1
end

function dump ()
    print(l_to_s(data_s))
end


---- Words ----

-- ( x y -- x y x y )
dup2 = {
    over, over
}

-- ( x y -- y )
nip = {
    swap, drop
}

-- ( -- value )
x = 1
o = -1
empty = 0

-- ( n -- bool )
not_zero = {
    0, eq, op_not,
}

-- ( value -- bool )
not_empty = not_zero

-- ( -- position )
random_position = {
    9, random
}

-- ( sign -- value )
from_sign = {
    dup, 'x', eq, iff,
    { drop, x }, elsef,
    { dup, 'o', eq, iff,
      { drop, o }, elsef,
      { dup, '.', eq, iff,
        { drop, empty }, elsef,
        { drop, false } } }
}

-- ( value -- sign )
to_sign = {
    dup, x, eq, iff,
    drop, 'x',
    dup, o, eq, iff,
    drop, 'o',
    dup, empty, eq, iff,
    drop, '.'
}
-- ( prev a b c -- next )
row_winner = {
    add, add, dup,
    x, 3, mul, eq, iff,
    { nip, x, swap }, nop,
    o, 3, mul, eq, iff,
    { drop, o }
}

-- ( board -- sign ) hideous but works
winner = {
    empty, swap,
    1, over, get, swap,
    2, over, get, swap,
    3, over, get, swap,
    dip, row_winner,
    4, over, get, swap,
    5, over, get, swap,
    6, over, get, swap,
    dip, row_winner,
    7, over, get, swap,
    8, over, get, swap,
    9, over, get, swap,
    dip, row_winner,
    1, over, get, swap,
    4, over, get, swap,
    7, over, get, swap,
    dip, row_winner,
    2, over, get, swap,
    5, over, get, swap,
    8, over, get, swap,
    dip, row_winner,
    3, over, get, swap,
    6, over, get, swap,
    9, over, get, swap,
    dip, row_winner,
    1, over, get, swap,
    5, over, get, swap,
    9, over, get, swap,
    dip, row_winner,
    3, over, get, swap,
    5, over, get, swap,
    7, over, get, swap,
    dip, row_winner,
    drop
}

-- ( board -- move true | false ) TODO
can_win = {
    dip, { false, 1 },
    { dup2, get,
      empty, eq, iff,
      { dup2, x, set,
        dup, winner, x, eq, iff,
        { dup2, empty, set, dip,
          { nip, true, 9 } },
        elsef, { dup2, empty, set } },
      nop,
      over, 9, eq, op_not, op_while,
      swap, suc, swap, again },
    drop, drop
}

-- ( board -- move true | false ) TODO
can_loose = {
    dip, { false, 1 },
    { dup2, get,
      empty, eq, iff,
      { dup2, o, set,
        dup, winner, o, eq, iff,
        { dup2, empty, set, dip,
          { nip, true, 9 } },
        elsef, { dup2, empty, set } },
      nop,
      over, 9, eq, op_not, op_while,
      swap, suc, swap, again },
    drop, drop
}

-- ( board -- board )
random_move = {
    { random_position,
      dup2, swap, get,
      not_empty, op_while,
      drop, again },
    over, x, set
}

-- ( board_str -- board )
parse_board = {
    to_list, new_list, swap, 1,
    { over, length, suc, over,
      eq, op_not, op_while,
      dup2, swap, get, from_sign,
      dup, iff,
      { swap, dip,
        { dip,
          { over, dup, length,
            suc, swap }, set } },
      elsef, { drop },
      suc, again },
    drop, drop
}


-- ( board -- board )
make_move = {
    dup, can_win, iff,
    { over, x, set }, elsef,
    { dup, can_loose, iff,
      { over, x, set }, elsef,
      { random_move } }
}

-- ( board -- board_str )
encode_board = {
    '', swap, 1,
    { dup, 10, eq, op_not, op_while,
      dup2, swap, get, to_sign,
      swap, dip,
      { rot, swap, cat, swap },
      suc, again },
    drop, drop
}

-- ( board_str -- board_str )
tictactoe = {
    parse_board,
    make_move,
    encode_board
}


---- Interpreter ----

function eval (word)
    return_s, ip, current = {}, 1, word
    while true do
        -- return from any finished threads
        while ip > #current do
            if #return_s == 0 then
                return
            else
                current, ip = table.unpack(table.remove(return_s))
            end
        end
        -- get current command
        com = current[ip]
        ip = ip + 1
        -- execute command
        if type(com) == 'function' then
            com()
        elseif type(com) == 'table' then
            table.insert(return_s, {current, ip})
            current, ip = com, 1
        else
            table.insert(data_s, com)
        end
    end
end


function better_entry (s)
    data_s = {s}
    eval(tictactoe)
    return table.remove(data_s)
end


---- Helpers ----

function l_to_s (l, d)
    d = d or 3 -- how deep will the printing go
    ans = '['
    for i = 1, #l do
        if type(l[i]) == 'function' then
            ans = ans .. ' [op]'
        elseif type(l[i]) == 'table' then
            if d > 0 then
                ans = ans .. ' ' .. l_to_s(l[i], d - 1)
            else
                ans = ans .. ' [...]'
            end
        else
            ans = ans .. ' ' .. tostring(l[i])
        end
    end
    return ans .. ' ]'
end

function print_stack ()
    print(l_to_s(data_s))
end


---- Dumb version ----

function bad_entry (s)
    local answer, moved, cell = '', false
    for i = 1, #s do
        cell = s:sub(i, i)
        if cell == '.' and not moved then
            cell = 'x'
            moved = true
        end
        answer = answer .. cell
    end
    return answer
end


---- Entry ----

entry = better_entry
